## org.eclipse.emf.query.conditions.eobjects
Enum TypeRelation

    java.lang.Object
      java.lang.Enum<TypeRelation>
          org.eclipse.emf.query.conditions.eobjects.TypeRelation

All Implemented Interfaces:
  Serializable, Comparable<TypeRelation>, Enumerator

    public enum TypeRelation

extends Enum<TypeRelation>
implements Enumerator

An enumerator for the kinds of relationships between EClasses/types. It is primarily used by `EObjectTypeRelationCondition` to check for relations between EObjects

Enum Constant Summary
`BASETYPE_LITERAL` A `TypeRelation` enumeration literal used to denote that one type is a base type of another.
`DIRECT_BASETYPE_LITERAL` A `TypeRelation` enumeration literal used to denote that one type is a direct super type of another.
`DIRECT_SUBTYPE_LITERAL` A `TypeRelation` enumeration literal used to denote that one type is a direct sub type of another.
`RELATED_TYPE_LITERAL` A `TypeRelation` enumeration literal used to denote the presence of a relationship between two types, regardless of the nature of this relationship, in other words, either type could be a parent of another, or they could be the same.
`SAMETYPE_LITERAL` A `TypeRelation` enumeration literal used to denote that two types are exactly the same.
`SAMETYPE_OR_BASETYPE_LITERAL` A `TypeRelation` enumeration literal used to denote that one type is either the same or a super type of another.
`SAMETYPE_OR_DIRECT_BASETYPE_LITERAL` A `TypeRelation` enumeration literal used to denote that one type is either the same or a direct base type of another.
`SAMETYPE_OR_DIRECT_SUBTYPE_LITERAL` A `TypeRelation` enumeration literal used to denote that one type is either the same or a direct sub type of another.
`SAMETYPE_OR_SUBTYPE_LITERAL` A `TypeRelation` enumeration literal used to denote that one type is either the same or a sub type of another.
`SUBTYPE_LITERAL` A `TypeRelation` enumeration literal used to denote that one type is a sub type of another.
`UNDEFINED_LITERAL` A `TypeRelation` enumeration literal used to denote an undefined relationship between two types which means the two types could or could not be related at all.
`UNRELATED_TYPE_LITERAL` A `TypeRelation` enumeration literal used to denote the absence of a relationship between two types, regardless of the nature of this relationship, in other words, either type should not be a parent of the other, nor they should be the same.

Field Summary
`static int` `BASETYPE` The integer value of the BASETYPE_LITERAL `TypeRelation` enumeration literal.
`static int` `DIRECT_BASETYPE` The integer value of the DIRECT_BASETYPE_LITERAL `TypeRelation` enumeration literal.
`static int` `DIRECT_SUBTYPE` The integer value of the DIRECT_SUBTYPE_LITERAL `TypeRelation` enumeration literal.
`static int` `RELATED_TYPE` The integer value of the RELATED_TYPE_LITERAL `TypeRelation` enumeration literal.
`static int` `SAMETYPE` The integer value of the SAMETYPE_LITERAL `TypeRelation` enumeration literal.
`static int` `SAMETYPE_OR_BASETYPE` The integer value of the SAMETYPE_OR_BASETYPE_LITERAL `TypeRelation` enumeration literal.
`static int` `SAMETYPE_OR_DIRECT_BASETYPE` The integer value of the SAMETYPE_OR_DIRECT_BASETYPE_LITERAL `TypeRelation` enumeration literal.
`static int` `SAMETYPE_OR_DIRECT_SUBTYPE` The integer value of the SAMETYPE_OR_DIRECT_SUBTYPE_LITERAL `TypeRelation` enumeration literal.
`static int` `SAMETYPE_OR_SUBTYPE` The integer value of the SAMETYPE_OR_SUBTYPE_LITERAL `TypeRelation` enumeration literal.
`static int` `SUBTYPE` The integer value of the SUBTYPE_LITERAL `TypeRelation` enumeration literal.
`static int` `UNDEFINED` The integer value of the UNDEFINED_LITERAL `TypeRelation` enumeration literal.
`static int` `UNRELATED_TYPE` The integer value of the UNRELATED_TYPE_LITERAL `TypeRelation` enumeration literal.
`static List<TypeRelation>` `VALUES` An immutable list of the enumeration literals declared by this enumerator

Method Summary
`static TypeRelation` `get(int value)` Gets the `TypeRelation` enumeration literal with the integer value specified in the argument.
`static TypeRelation` `get(String name)` Gets the `TypeRelation` enumeration literal with the name specified in the argument.
`String` `getLiteral()`
`String` `getName()`
`static int` `getTotalCount()` Answers how many enumeration literals declared by this enumerator.
`int` `getValue()`
`static TypeRelation` `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static TypeRelation[]` `values()` Returns an array containing the constants of this enum type, in the order they're declared.

Methods inherited from class java.lang.Enum
`clone, compareTo, equals, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Enum Constant Detail

### UNDEFINED_LITERAL

    public static final TypeRelation UNDEFINED_LITERAL

  A `TypeRelation` enumeration literal used to denote an undefined relationship between two types which means the two types could or could not be related at all.

### RELATED_TYPE_LITERAL

    public static final TypeRelation RELATED_TYPE_LITERAL

  A `TypeRelation` enumeration literal used to denote the presence of a relationship between two types, regardless of the nature of this relationship, in other words, either type could be a parent of another, or they could be the same.

### UNRELATED_TYPE_LITERAL

    public static final TypeRelation UNRELATED_TYPE_LITERAL

  A `TypeRelation` enumeration literal used to denote the absence of a relationship between two types, regardless of the nature of this relationship, in other words, either type should not be a parent of the other, nor they should be the same.

### SAMETYPE_LITERAL

    public static final TypeRelation SAMETYPE_LITERAL

  A `TypeRelation` enumeration literal used to denote that two types are exactly the same.

### BASETYPE_LITERAL

    public static final TypeRelation BASETYPE_LITERAL

  A `TypeRelation` enumeration literal used to denote that one type is a base type of another.

### SUBTYPE_LITERAL

    public static final TypeRelation SUBTYPE_LITERAL

  A `TypeRelation` enumeration literal used to denote that one type is a sub type of another.

### DIRECT_BASETYPE_LITERAL

    public static final TypeRelation DIRECT_BASETYPE_LITERAL

  A `TypeRelation` enumeration literal used to denote that one type is a direct super type of another.

### DIRECT_SUBTYPE_LITERAL

    public static final TypeRelation DIRECT_SUBTYPE_LITERAL

  A `TypeRelation` enumeration literal used to denote that one type is a direct sub type of another.

### SAMETYPE_OR_DIRECT_SUBTYPE_LITERAL

    public static final TypeRelation SAMETYPE_OR_DIRECT_SUBTYPE_LITERAL

  A `TypeRelation` enumeration literal used to denote that one type is either the same or a direct sub type of another.

### SAMETYPE_OR_DIRECT_BASETYPE_LITERAL

    public static final TypeRelation SAMETYPE_OR_DIRECT_BASETYPE_LITERAL

  A `TypeRelation` enumeration literal used to denote that one type is either the same or a direct base type of another.

### SAMETYPE_OR_SUBTYPE_LITERAL

    public static final TypeRelation SAMETYPE_OR_SUBTYPE_LITERAL

  A `TypeRelation` enumeration literal used to denote that one type is either the same or a sub type of another.

### SAMETYPE_OR_BASETYPE_LITERAL

    public static final TypeRelation SAMETYPE_OR_BASETYPE_LITERAL

  A `TypeRelation` enumeration literal used to denote that one type is either the same or a super type of another.

Field Detail

### UNDEFINED

    public static final int UNDEFINED

  The integer value of the UNDEFINED_LITERAL `TypeRelation` enumeration literal.

### RELATED_TYPE

    public static final int RELATED_TYPE

  The integer value of the RELATED_TYPE_LITERAL `TypeRelation` enumeration literal.

### UNRELATED_TYPE

    public static final int UNRELATED_TYPE

  The integer value of the UNRELATED_TYPE_LITERAL `TypeRelation` enumeration literal.

### SAMETYPE

    public static final int SAMETYPE

  The integer value of the SAMETYPE_LITERAL `TypeRelation` enumeration literal.

### BASETYPE

    public static final int BASETYPE

  The integer value of the BASETYPE_LITERAL `TypeRelation` enumeration literal.

### SUBTYPE

    public static final int SUBTYPE

  The integer value of the SUBTYPE_LITERAL `TypeRelation` enumeration literal.

### DIRECT_BASETYPE

    public static final int DIRECT_BASETYPE

  The integer value of the DIRECT_BASETYPE_LITERAL `TypeRelation` enumeration literal.

### DIRECT_SUBTYPE

    public static final int DIRECT_SUBTYPE

  The integer value of the DIRECT_SUBTYPE_LITERAL `TypeRelation` enumeration literal.

### SAMETYPE_OR_DIRECT_SUBTYPE

    public static final int SAMETYPE_OR_DIRECT_SUBTYPE

  The integer value of the SAMETYPE_OR_DIRECT_SUBTYPE_LITERAL `TypeRelation` enumeration literal.

### SAMETYPE_OR_DIRECT_BASETYPE

    public static final int SAMETYPE_OR_DIRECT_BASETYPE

  The integer value of the SAMETYPE_OR_DIRECT_BASETYPE_LITERAL `TypeRelation` enumeration literal.

### SAMETYPE_OR_SUBTYPE

    public static final int SAMETYPE_OR_SUBTYPE

  The integer value of the SAMETYPE_OR_SUBTYPE_LITERAL `TypeRelation` enumeration literal.

### SAMETYPE_OR_BASETYPE

    public static final int SAMETYPE_OR_BASETYPE

  The integer value of the SAMETYPE_OR_BASETYPE_LITERAL `TypeRelation` enumeration literal.

### VALUES

    public static final List<TypeRelation> VALUES

  An immutable list of the enumeration literals declared by this enumerator

Method Detail

### values

    public static final TypeRelation[] values()

  Returns an array containing the constants of this enum type, in the order they're declared. This method may be used to iterate over the constants as follows:

      for(TypeRelation c : TypeRelation.values())
              System.out.println(c);

  Returns:
    an array containing the constants of this enum type, in the order they're declared

### valueOf

    public static TypeRelation valueOf(String name)

  Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

  Parameters:
    `name` - the name of the enum constant to be returned.
  Returns:
    the enum constant with the specified name
  Throws:
    `IllegalArgumentException` - if this enum type has no constant with the specified name

### get

    public static TypeRelation get(int value)

  Gets the `TypeRelation` enumeration literal with the integer value specified in the argument.

  Parameters:
    `value` - An integer representing the value of a `TypeRelation` enumeration literal
  Returns:
    the `TypeRelation` having this name or null if the name is not recognized

### get

    public static TypeRelation get(String name)

  Gets the `TypeRelation` enumeration literal with the name specified in the argument.

  Parameters:
    `name` - A string representing the name of a `TypeRelation` enumeration literal
  Returns:
    the `TypeRelation` having this name or `null` if the name is not recognized

### getTotalCount

    public static int getTotalCount()

  Answers how many enumeration literals declared by this enumerator.

  Returns:
    The total count of all enumeration literals declared by this enumerator

### getLiteral

    public String getLiteral()

  Specified by:
    `getLiteral` in interface `Enumerator`

### getName

    public String getName()

  Specified by:
    `getName` in interface `Enumerator`

### getValue

    public int getValue()

  Specified by:
    `getValue` in interface `Enumerator`

Copyright 2002, 2007 IBM Corporation and others. All Rights Reserved.